
  ' FreePDQ2.Bas  06-20-91
  ' A small, fast multi-drive free disk space utility.
  ' Microsoft QuickBASIC 4.5, and Cresent Software PDQ/PRO libraries.
  ' Copyright 1990, 1991 by Thomas E. McCormick. All rights reserved.
  ' Placed into the public domain by the author.
  ' --------------------------------------------------------------
  ' Source may be used in part or in total without restriction.
  ' Reports drive letter, media type, total space amount, free
  ' space amount, and free space percentage for 1 or more drives.
  ' Network drives are handled.  Large capacity drives are handled.
  ' The data is displayed at one line per drive single spaced.
  ' If no drive is specified, the default drive amounts are shown.
  ' Drive(s) are specified in the command tail: colons and spaces
  ' are not required, but may be entered if desired.  Error
  ' conditions such as drive not ready, invalid drive letter, etc.
  ' are trapped without a critical error message (Abort, Retry,..)
  ' When those errors occur, the drive and five "?" are displayed.
  ' --------------------------------------------------------------
  ' Example: To see free space on drives C:, D:, and E:, enter:
  '          free cde
  '      or  free c d e
  '      or  free c:d:e:
  '      or  free c: d: e:
  '
  ' The output may be redirected: i.e.,  free cde >DiskRept.Doc
  ' -------------------------------------------------------------
  '
  ' Example output from "free abcdefghij"
  '
  ' A: 5 HD Diskette has     130,048 bytes free ( 10 %) of total   1,213,952.
  ' B: 5 SD Diskette has     326,656 bytes free ( 90 %) of total     362,496.
  ' C: Fixed Drive... has  12,795,904 bytes free ( 38 %) of total  33,419,264.
  ' D: Fixed Drive... has   5,646,336 bytes free ( 16 %) of total  33,419,264.
  ' E: Fixed Drive... has     507,904 bytes free ( 12 %) of total   4,173,824.
  ' F: Fixed Drive... has   5,748,736 bytes free ( 17 %) of total  33,435,648.
  ' G: Fixed Drive... has   3,084,288 bytes free ( 33 %) of total   9,207,808.
  ' H: 3 HD Diskette has     899,584 bytes free ( 61 %) of total   1,457,664.
  ' I: 3 DD Diskette has     132,096 bytes free ( 18 %) of total     730,112.
  ' J: ?????
  '
  ' J: is an invalid drive letter: result is same if door open, unformatted.
  '
  ' -------------------------------------------------------------

   DEFINT A-Z

  'PDQ modules:
  '$INCLUDE: 'F:\PDQ\PDQDECL.BAS'

  'PRO modules:
   DECLARE FUNCTION DiskRoom& (Drive$)
   DECLARE FUNCTION DiskSize& (Drive$)
   DECLARE FUNCTION GetDrive% ()
   DECLARE FUNCTION OneColor% (V.Fg%, V.Bg%)
   DECLARE SUB GetColor (V.Fg%, V.Bg%)
   DECLARE FUNCTION ReadTest% (Drive$)
   DECLARE SUB SplitColor (Colr%, FG%, BG%)

  ' ---------------------------------------------------------------------

    DIM Registers AS RegType
    Dk$ = "Diskette "

  ' ---------------------------------------------------------------------


Initialize:

   DEF SEG = 64: CrtRowsMax% = PEEK(132): DEF SEG

Begin:

   DriveList$ = COMMAND$
   IF DriveList$ = "" THEN
      DriveList$ = CHR$(GetDrive%)         'Get default drive letter
   END IF

   DriveList$ = UCASE$(DriveList$)         'toupper
   Clen% = LEN(DriveList$)                 'Length of drive list string


DoCmdTail:

   FOR DriveLetters% = 1 TO Clen%            'Drive(s) were specified
     C$ = MID$(DriveList$, DriveLetters%, 1) 'COMMAND$ is upper case
     Drive% = INSTR("ABCDEFGHIJKLMNOPQRSTUVWXYZ", C$)
     IF Drive% > 0 THEN                      'Skip colons, spaces, etc
        Q.Drive$ = C$                        'The drive letter uppercase
        DriveReady% = ReadTest%(Q.Drive$)
           IF NOT DriveReady% THEN           'Invalid, door open, etc.
              DriveDesc$ = "????? "          'Report it anyway
              GOSUB Q.ReportDiskInfo
              GOTO NextDrive
           END IF
        Q.FreeSpace& = DiskRoom&(Q.Drive$)
        Q.TotalSpace& = DiskSize&(Q.Drive$)
        Q.Tot& = Q.TotalSpace& \ 100
           IF Q.TotalSpace& > 10000 THEN     'No div by 0: i.e., inval drv
              Q.FreePct& = (Q.FreeSpace& \ Q.Tot&)
           END IF
        GOSUB Q.GetMediaType                 'For specific desc comment
        GOSUB Q.ReportDiskInfo               'Output 1 line per drive
     END IF


NextDrive:

   NEXT DriveLetters%

   SYSTEM
  '------


Q.GetMediaType:

    Registers.AX = &H1C00                    'get disk(ette) ID byte integer
    Registers.DX = ASC(Q.Drive$) - 64        'A=0, B=1, etc.
    CALL InterruptX(&H21, Registers)         'PDQ
    DEF SEG = Registers.DS

    Q.MediaIDByte% = PEEK(Registers.BX)
    DEF SEG
    DriveDesc$ = "               "           'In case unidentified

    SELECT CASE Q.MediaIDByte%

    CASE &HF0                                'Hi/Extended density 3 1/2
      IF Q.TotalSpace& > 1300000 THEN
         DriveDesc$ = "3" + CHR$(171) + " HD " + Dk$
      END IF
      IF Q.TotalSpace& > 2500000 THEN
         DriveDesc$ = "3" + CHR$(171) + " XD " + Dk$
      END IF

    CASE &HF8
      DriveDesc$ = "Fixed Drive... "         'Non-removable

    CASE &HF9
      IF Q.TotalSpace& > 150000 THEN
         DriveDesc$ = "5" + CHR$(172) + " SS " + Dk$
      END IF

      IF Q.TotalSpace& > 170000 THEN
         DriveDesc$ = "5" + CHR$(172) + " SS " + Dk$
      END IF

      IF Q.TotalSpace& > 300000 THEN         '8 sector rather than 9
         DriveDesc$ = "5" + CHR$(172) + " SD " + Dk$
      END IF

      IF Q.TotalSpace& > 340000 THEN         '360kb single den 5 1/4"
         DriveDesc$ = "5" + CHR$(172) + " SD " + Dk$
      END IF

      IF Q.TotalSpace& > 700000 THEN         'Double density 3 1/2"
         DriveDesc$ = "3" + CHR$(171) + " DD " + Dk$
      END IF

      IF Q.TotalSpace& > 900000 THEN         'high den 1.2mb 5 1/4"
         DriveDesc$ = "5" + CHR$(172) + " HD " + Dk$
      END IF

    CASE &HFD
         DriveDesc$ = "5" + CHR$(172) + " SD " + Dk$

    CASE ELSE

    END SELECT

    RETURN
   '------


Q.ReportDiskInfo:

   Lin$ = Q.Drive$ + ": " + DriveDesc$
        IF Q.TotalSpace& < 1 THEN GOTO Q.RptLine  'Invalid drive, etc.

   Lin$ = Lin$ + "has "
   S$ = STR$(Q.FreeSpace&)
        GOSUB W.Commatize
   S$ = SPACE$(11) + S$        ' Right justify
   S$ = RIGHT$(S$, 11)

   Lin$ = Lin$ + S$ + " bytes free ("
   S$ = STR$(Q.FreePct&)
        GOSUB W.Commatize
   S$ = "   " + S$
   S$ = RIGHT$(S$, 3)

   Lin$ = Lin$ + S$ + " %) of total "

   S$ = STR$(Q.TotalSpace&)
        GOSUB W.Commatize
   S$ = SPACE$(11) + S$        ' Right justify
   S$ = RIGHT$(S$, 11)

   Lin$ = Lin$ + S$ + "."
 

Q.RptLine:

   'CALL PDQCPRINT(Lin$, CSRLIN, 1)     ' Report line is output here
   PRINT Lin$

   Q.FreeSpace& = 0                    ' Clean up in case next drive letter invalid
   Q.TotalSpace& = 0
   Q.FreePct& = 0

   RETURN
  '------


W.Commatize:

  '-----------------------------------------------------------------------
  'Call with digital string in S$, returns S$ containing commas (longer!)
  '-----------------------------------------------------------------------

  S$ = LTRIM$(S$): S$ = SPACE$(12) + S$: S$ = RIGHT$(S$, 12)
  S2$ = LEFT$(S$, 3) + "," + MID$(S$, 4, 3) + "," + MID$(S$, 7, 3)
  S2$ = S2$ + "," + RIGHT$(S$, 3)           ' Now length is 15

  FOR Temp% = 1 TO LEN(S2$)
      C$ = MID$(S2$, Temp%, 1)              ' One char at a time.
      Num% = INSTR("0123456789-", C$)       ' Look for numeric char
      IF (Num% <> 0) THEN                   ' Drop until 1st one
          S$ = RIGHT$(S2$, (16 - Temp%))    ' Then keep only numeric
          EXIT FOR                          ' ...and quit loop
      END IF
  NEXT Temp%

W.Commatize.Exit:

  RETURN
 '------

